<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHesapHareketleriHesap ArrayType
 * @subpackage Arrays
 */
class ArrayOfHesapHareketleriHesap extends AbstractStructArrayBase
{
    /**
     * The hesap
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HesapHareketleriHesap[]
     */
    public $hesap;
    /**
     * Constructor method for ArrayOfHesapHareketleriHesap
     * @uses ArrayOfHesapHareketleriHesap::setHesap()
     * @param \StructType\HesapHareketleriHesap[] $hesap
     */
    public function __construct(array $hesap = array())
    {
        $this
            ->setHesap($hesap);
    }
    /**
     * Get hesap value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HesapHareketleriHesap[]|null
     */
    public function getHesap()
    {
        return isset($this->hesap) ? $this->hesap : null;
    }
    /**
     * This method is responsible for validating the values passed to the setHesap method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHesap method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHesapForArrayConstraintsFromSetHesap(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfHesapHareketleriHesapHesapItem) {
            // validation for constraint: itemType
            if (!$arrayOfHesapHareketleriHesapHesapItem instanceof \StructType\HesapHareketleriHesap) {
                $invalidValues[] = is_object($arrayOfHesapHareketleriHesapHesapItem) ? get_class($arrayOfHesapHareketleriHesapHesapItem) : sprintf('%s(%s)', gettype($arrayOfHesapHareketleriHesapHesapItem), var_export($arrayOfHesapHareketleriHesapHesapItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The hesap property can only contain items of type \StructType\HesapHareketleriHesap, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set hesap value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HesapHareketleriHesap[] $hesap
     * @return \ArrayType\ArrayOfHesapHareketleriHesap
     */
    public function setHesap(array $hesap = array())
    {
        // validation for constraint: array
        if ('' !== ($hesapArrayErrorMessage = self::validateHesapForArrayConstraintsFromSetHesap($hesap))) {
            throw new \InvalidArgumentException($hesapArrayErrorMessage, __LINE__);
        }
        if (is_null($hesap) || (is_array($hesap) && empty($hesap))) {
            unset($this->hesap);
        } else {
            $this->hesap = $hesap;
        }
        return $this;
    }
    /**
     * Add item to hesap value
     * @throws \InvalidArgumentException
     * @param \StructType\HesapHareketleriHesap $item
     * @return \ArrayType\ArrayOfHesapHareketleriHesap
     */
    public function addToHesap(\StructType\HesapHareketleriHesap $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HesapHareketleriHesap) {
            throw new \InvalidArgumentException(sprintf('The hesap property can only contain items of type \StructType\HesapHareketleriHesap, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->hesap[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HesapHareketleriHesap|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HesapHareketleriHesap|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HesapHareketleriHesap|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HesapHareketleriHesap|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HesapHareketleriHesap|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string hesap
     */
    public function getAttributeName()
    {
        return 'hesap';
    }
}
