<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for hesapHareketleriHesap StructType
 * @subpackage Structs
 */
class HesapHareketleriHesap extends AbstractStructBase
{
    /**
     * The musteriNo
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $musteriNo;
    /**
     * The hesapNo
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $hesapNo;
    /**
     * The hesapIban
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $hesapIban;
    /**
     * The hesapTcknVkn
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $hesapTcknVkn;
    /**
     * The hesapHareket
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HesapHareket[]
     */
    public $hesapHareket;
    /**
     * Constructor method for hesapHareketleriHesap
     * @uses HesapHareketleriHesap::setMusteriNo()
     * @uses HesapHareketleriHesap::setHesapNo()
     * @uses HesapHareketleriHesap::setHesapIban()
     * @uses HesapHareketleriHesap::setHesapTcknVkn()
     * @uses HesapHareketleriHesap::setHesapHareket()
     * @param string $musteriNo
     * @param string $hesapNo
     * @param string $hesapIban
     * @param string $hesapTcknVkn
     * @param \StructType\HesapHareket[] $hesapHareket
     */
    public function __construct($musteriNo = null, $hesapNo = null, $hesapIban = null, $hesapTcknVkn = null, array $hesapHareket = array())
    {
        $this
            ->setMusteriNo($musteriNo)
            ->setHesapNo($hesapNo)
            ->setHesapIban($hesapIban)
            ->setHesapTcknVkn($hesapTcknVkn)
            ->setHesapHareket($hesapHareket);
    }
    /**
     * Get musteriNo value
     * @return string|null
     */
    public function getMusteriNo()
    {
        return $this->musteriNo;
    }
    /**
     * Set musteriNo value
     * @param string $musteriNo
     * @return \StructType\HesapHareketleriHesap
     */
    public function setMusteriNo($musteriNo = null)
    {
        // validation for constraint: string
        if (!is_null($musteriNo) && !is_string($musteriNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($musteriNo, true), gettype($musteriNo)), __LINE__);
        }
        $this->musteriNo = $musteriNo;
        return $this;
    }
    /**
     * Get hesapNo value
     * @return string|null
     */
    public function getHesapNo()
    {
        return $this->hesapNo;
    }
    /**
     * Set hesapNo value
     * @param string $hesapNo
     * @return \StructType\HesapHareketleriHesap
     */
    public function setHesapNo($hesapNo = null)
    {
        // validation for constraint: string
        if (!is_null($hesapNo) && !is_string($hesapNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hesapNo, true), gettype($hesapNo)), __LINE__);
        }
        $this->hesapNo = $hesapNo;
        return $this;
    }
    /**
     * Get hesapIban value
     * @return string|null
     */
    public function getHesapIban()
    {
        return $this->hesapIban;
    }
    /**
     * Set hesapIban value
     * @param string $hesapIban
     * @return \StructType\HesapHareketleriHesap
     */
    public function setHesapIban($hesapIban = null)
    {
        // validation for constraint: string
        if (!is_null($hesapIban) && !is_string($hesapIban)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hesapIban, true), gettype($hesapIban)), __LINE__);
        }
        $this->hesapIban = $hesapIban;
        return $this;
    }
    /**
     * Get hesapTcknVkn value
     * @return string|null
     */
    public function getHesapTcknVkn()
    {
        return $this->hesapTcknVkn;
    }
    /**
     * Set hesapTcknVkn value
     * @param string $hesapTcknVkn
     * @return \StructType\HesapHareketleriHesap
     */
    public function setHesapTcknVkn($hesapTcknVkn = null)
    {
        // validation for constraint: string
        if (!is_null($hesapTcknVkn) && !is_string($hesapTcknVkn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hesapTcknVkn, true), gettype($hesapTcknVkn)), __LINE__);
        }
        $this->hesapTcknVkn = $hesapTcknVkn;
        return $this;
    }
    /**
     * Get hesapHareket value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HesapHareket[]|null
     */
    public function getHesapHareket()
    {
        return isset($this->hesapHareket) ? $this->hesapHareket : null;
    }
    /**
     * This method is responsible for validating the values passed to the setHesapHareket method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHesapHareket method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHesapHareketForArrayConstraintsFromSetHesapHareket(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $hesapHareketleriHesapHesapHareketItem) {
            // validation for constraint: itemType
            if (!$hesapHareketleriHesapHesapHareketItem instanceof \StructType\HesapHareket) {
                $invalidValues[] = is_object($hesapHareketleriHesapHesapHareketItem) ? get_class($hesapHareketleriHesapHesapHareketItem) : sprintf('%s(%s)', gettype($hesapHareketleriHesapHesapHareketItem), var_export($hesapHareketleriHesapHesapHareketItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The hesapHareket property can only contain items of type \StructType\HesapHareket, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set hesapHareket value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HesapHareket[] $hesapHareket
     * @return \StructType\HesapHareketleriHesap
     */
    public function setHesapHareket(array $hesapHareket = array())
    {
        // validation for constraint: array
        if ('' !== ($hesapHareketArrayErrorMessage = self::validateHesapHareketForArrayConstraintsFromSetHesapHareket($hesapHareket))) {
            throw new \InvalidArgumentException($hesapHareketArrayErrorMessage, __LINE__);
        }
        if (is_null($hesapHareket) || (is_array($hesapHareket) && empty($hesapHareket))) {
            unset($this->hesapHareket);
        } else {
            $this->hesapHareket = $hesapHareket;
        }
        return $this;
    }
    /**
     * Add item to hesapHareket value
     * @throws \InvalidArgumentException
     * @param \StructType\HesapHareket $item
     * @return \StructType\HesapHareketleriHesap
     */
    public function addToHesapHareket(\StructType\HesapHareket $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HesapHareket) {
            throw new \InvalidArgumentException(sprintf('The hesapHareket property can only contain items of type \StructType\HesapHareket, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->hesapHareket[] = $item;
        return $this;
    }
}
